/*************************************************  Channel Functions Header  **************************************************

	Red Rapids
	797 North Grove Rd
	Suite 101
	Richardson, TX 75081
	www.redrapids.com | support@redrapids.com

	Copyright (c) 2019  Red Rapids, Inc.

	Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation
	files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,
	modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software
	is furnished to do so, subject to the following conditions:

	The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
	OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
	LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR
	IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

*************************************************  Channel Functions Header  **************************************************/

#ifndef _CHANNEL_FUNCTIONS_H_
#define _CHANNEL_FUNCTIONS_H_

#if defined(__cplusplus)
	extern "C" {
#endif

// Structure to store the synchronizer configuration settings.
typedef struct
{
	unsigned StartEvent;
	unsigned StopEvent;
	unsigned SampleCount;
} s_Synchronizer;

// Structure to store the results returned by a channel status query to the device.
typedef struct
{
	unsigned DMAMarker;
	unsigned Error[2];
} s_ChannelStatus;

// Structure to store interrupt mask settings assigned to each type of channel event.
typedef struct
{
	unsigned DMAMarker;
	unsigned Error[2];
} s_ChannelIntMask;

// Prototypes for each of the channel functions.
void ChannelMask(s_Handle *p_HW, unsigned ChannelNumber, s_ChannelIntMask ChannelIntMask);
int ChannelStatus(s_Handle *p_HW, unsigned ChannelNumber, s_ChannelStatus *p_Channel);
void ChannelStatusClear(s_Handle *p_HW, unsigned ChannelNumber);
void FlowControl(s_Handle *p_HW, unsigned ChannelNumber, unsigned OnOff);
int FlowStatus(s_Handle *p_HW, unsigned ChannelNumber);
int ReadyStatus(s_Handle *p_HW, unsigned ChannelNumber);
void SynchronizerSettings(s_Handle *p_HW, unsigned ChannelNumber, s_Synchronizer Synchronizer);

#ifdef __cplusplus
}
#endif

#endif
